package com.fp.persistence.pgeneral.product;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENESUBPRODCLIENTDATA*/
@Embeddable
public class TgeneSubprodClientDataKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="MODULECODE", nullable=false,updatable=false)

/**
* Codigo de modulo
*/
private String modulecode;

@Column(name="PRODUCTCODE", nullable=false,updatable=false)

/**
* Codigo de producto
*/
private String productcode;

@Column(name="SUBPRODUCTCODE", nullable=false,updatable=false)

/**
* Codigo de subproducto
*/
private String subproductcode;

@Column(name="PERSONTYPECATALOG", nullable=false,updatable=false)

/**
* Codigo de catalogo  01 Natural, 02 Juridico
*/
private String persontypecatalog;

@Column(name="PERSONTYPECATALOGCODE", nullable=false,updatable=false)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
*/
private String persontypecatalogcode;

@Column(name="RELATIONSHIPCODE", nullable=false,updatable=false)

/**
* Codigo de relacion de la cuenta con el cliente
*/
private String relationshipcode;

@Column(name="TITLE", nullable=false,updatable=false)

/**
* Codigo de informacion de clientes requerido.
*/
private String title;

/**Contructor por defecto*/
public TgeneSubprodClientDataKey(){}
/**Contructor de TgeneSubprodClientDataKey
@param pModulecode Codigo de modulo
@param pProductcode Codigo de producto
@param pSubproductcode Codigo de subproducto
@param pPersontypecatalog Codigo de catalogo  01 Natural, 02 Juridico
@param pPersontypecatalogcode Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
@param pRelationshipcode Codigo de relacion de la cuenta con el cliente
@param pTitle Codigo de informacion de clientes requerido.
*/
public TgeneSubprodClientDataKey(String pModulecode,String pProductcode,String pSubproductcode,String pPersontypecatalog,String pPersontypecatalogcode,String pRelationshipcode,String pTitle){
 modulecode=pModulecode;
 productcode=pProductcode;
 subproductcode=pSubproductcode;
 persontypecatalog=pPersontypecatalog;
 persontypecatalogcode=pPersontypecatalogcode;
 relationshipcode=pRelationshipcode;
 title=pTitle;
}
/**Obtiene el valor de modulecode
@return valor de modulecode*/
public String getModulecode(){
  return modulecode;
}
/**Fija el valor de modulecode
@param pModulecode nuevo Valor de modulecode*/
public void setModulecode(String pModulecode){
  modulecode=pModulecode;
}

/**Obtiene el valor de productcode
@return valor de productcode*/
public String getProductcode(){
  return productcode;
}
/**Fija el valor de productcode
@param pProductcode nuevo Valor de productcode*/
public void setProductcode(String pProductcode){
  productcode=pProductcode;
}

/**Obtiene el valor de subproductcode
@return valor de subproductcode*/
public String getSubproductcode(){
  return subproductcode;
}
/**Fija el valor de subproductcode
@param pSubproductcode nuevo Valor de subproductcode*/
public void setSubproductcode(String pSubproductcode){
  subproductcode=pSubproductcode;
}

/**Obtiene el valor de persontypecatalog
@return valor de persontypecatalog*/
public String getPersontypecatalog(){
  return persontypecatalog;
}
/**Fija el valor de persontypecatalog
@param pPersontypecatalog nuevo Valor de persontypecatalog*/
public void setPersontypecatalog(String pPersontypecatalog){
  persontypecatalog=pPersontypecatalog;
}

/**Obtiene el valor de persontypecatalogcode
@return valor de persontypecatalogcode*/
public String getPersontypecatalogcode(){
  return persontypecatalogcode;
}
/**Fija el valor de persontypecatalogcode
@param pPersontypecatalogcode nuevo Valor de persontypecatalogcode*/
public void setPersontypecatalogcode(String pPersontypecatalogcode){
  persontypecatalogcode=pPersontypecatalogcode;
}

/**Obtiene el valor de relationshipcode
@return valor de relationshipcode*/
public String getRelationshipcode(){
  return relationshipcode;
}
/**Fija el valor de relationshipcode
@param pRelationshipcode nuevo Valor de relationshipcode*/
public void setRelationshipcode(String pRelationshipcode){
  relationshipcode=pRelationshipcode;
}

/**Obtiene el valor de title
@return valor de title*/
public String getTitle(){
  return title;
}
/**Fija el valor de title
@param pTitle nuevo Valor de title*/
public void setTitle(String pTitle){
  title=pTitle;
}

/**Implementación de la comparación de TgeneSubprodClientDataKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneSubprodClientDataKey))return false;
  TgeneSubprodClientDataKey that = (TgeneSubprodClientDataKey) o;
  if (this.getModulecode() == null || that.getModulecode() == null){
      return false;
  }
  if (! this.getModulecode().equals(that.getModulecode())){
    return false;
  }
  if (this.getProductcode() == null || that.getProductcode() == null){
      return false;
  }
  if (! this.getProductcode().equals(that.getProductcode())){
    return false;
  }
  if (this.getSubproductcode() == null || that.getSubproductcode() == null){
      return false;
  }
  if (! this.getSubproductcode().equals(that.getSubproductcode())){
    return false;
  }
  if (this.getPersontypecatalog() == null || that.getPersontypecatalog() == null){
      return false;
  }
  if (! this.getPersontypecatalog().equals(that.getPersontypecatalog())){
    return false;
  }
  if (this.getPersontypecatalogcode() == null || that.getPersontypecatalogcode() == null){
      return false;
  }
  if (! this.getPersontypecatalogcode().equals(that.getPersontypecatalogcode())){
    return false;
  }
  if (this.getRelationshipcode() == null || that.getRelationshipcode() == null){
      return false;
  }
  if (! this.getRelationshipcode().equals(that.getRelationshipcode())){
    return false;
  }
  if (this.getTitle() == null || that.getTitle() == null){
      return false;
  }
  if (! this.getTitle().equals(that.getTitle())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneSubprodClientDataKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getModulecode() == null ? 0 : this.getModulecode().hashCode());
    result = result * 37 + (this.getProductcode() == null ? 0 : this.getProductcode().hashCode());
    result = result * 37 + (this.getSubproductcode() == null ? 0 : this.getSubproductcode().hashCode());
    result = result * 37 + (this.getPersontypecatalog() == null ? 0 : this.getPersontypecatalog().hashCode());
    result = result * 37 + (this.getPersontypecatalogcode() == null ? 0 : this.getPersontypecatalogcode().hashCode());
    result = result * 37 + (this.getRelationshipcode() == null ? 0 : this.getRelationshipcode().hashCode());
    result = result * 37 + (this.getTitle() == null ? 0 : this.getTitle().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
